#!/usr/bin/env python

import psycopg2, sys
from optparse import OptionParser
import traceback, pickle
import Polygon, math

cur =  None
handled = 0
resultfile = None

def distance(lat1,  lon1,  lat2,  lon2):
    radius =   6371 # km

    dlat =   math.radians(lat2 -  lat1)
    dlon =   math.radians(lon2 -  lon1)
    a =   math.sin(dlat /  2) *   math.sin(dlat /  2) +   math.cos(math.radians(lat1)) *   math.cos(math.radians(lat2)) *   math.sin(dlon /  2) *   math.sin(dlon /  2)
    c =   2 *   math.atan2(math.sqrt(a),   math.sqrt(1 -  a))
    d =   radius *   c
    return d *  1000

def main():
    global cur, filelength, truelocations, estimatedlocations, resultfile
    
    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Analyze algorithm 1')
    parser.add_option('-p', '--password', action='store', type='string', dest='password', default='', help='Set database password')
    parser.add_option('-u', '--username', action='store', type='string', dest='username', default='', help='Set database username')
    parser.add_option('-n', '--hostname', action='store', type='string', dest='hostname', default='localhost', help='Set database hostname')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default='gloc', help='Set database name')
    parser.add_option('-r', '--resultfile', action='store', type='string', dest='resultfile', default='', help='File to save result')

    (options, args) = parser.parse_args()

    fid =  None

    if len(args) != 1:
        parser.error("You must specify file to be parsed")

    if not options.resultfile:
        parser.error("You must specify result")

    try: resultfile = open(options.resultfile, 'w')
    except: parser.error("Error opening resultfile")

    cellist = None
    results = []
    linecnt = 0

    try:
        conn = psycopg2.connect("dbname='%s' user='%s' host='%s' password='%s'"%(options.dbname, options.username, options.hostname, options.password))
        cur = conn.cursor()

        infile = open(args[0], 'r')

        for line in infile:
            result = eval(line)
            if result:
                results.append(linecnt)

            linecnt += 1

    except:
        print "ERROR %s"%(sys.exc_info()[1]);
        traceback.print_exc()

    print "\nCount: %s" % len(results)

    pickle.dump(results, resultfile)        
    resultfile.close()

def locationQuery(timestamp, lat, lon, imei, values):
    global cur, filelength, handled, truelocations, estimatedlocations, resultfile

    area = None
    for entry in values:
        if entry['type'] == 'gsm':
            cur.execute("SELECT cid FROM cells WHERE la =%s AND mcc =%s AND mnc =%s AND cellid =%s;" % (entry['la'], entry['mcc'], entry['mnc'], entry['cellid']))
            cidres =  cur.fetchall()
            if cidres: 
                cur.execute("SELECT area FROM algotestground.simpleareas WHERE cid=%s;" % (cidres[0][0]))

        result = cur.fetchall()
        if result: 
            if len(result) > 0: 
                newpol = [(float(y[0]), float(y[1])) for y in [x.split(',') for x in result[0][0].split(';')]]
                if len(newpol) > 3: 
                    area = Polygon.Polygon(newpol)

        #Lots of lazy copy paste from algo2, most stuff here could be done in a much better way
                        
    if area: 
        return True
    return False


        #Illustrations to be made (so we need to be able to dump)
        #real track vs estimated track
        #real position, all candidates and choosen candidate for a single cell (should color code the candidates depeding uppon how close they are to a match)
        #TODO: Include option to dump all information for all cells to file?
        #TODO: Put in option in glocalizer for specifying radius when rendering stuff

if __name__ == "__main__":
    main()

