#!/usr/bin/env python

import psycopg2, sys
from optparse import OptionParser
import traceback, pickle
import Polygon, math

cur =  None
handled = 0
resultfile = None


def main():
    global cur, filelength, truelocations, estimatedlocations, dumpcell, dumpfile, resultfile
    
    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Analyze algorithm 1')
    parser.add_option('-p', '--password', action='store', type='string', dest='password', default='', help='Set database password')
    parser.add_option('-u', '--username', action='store', type='string', dest='username', default='', help='Set database username')
    parser.add_option('-n', '--hostname', action='store', type='string', dest='hostname', default='localhost', help='Set database hostname')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default='gloc', help='Set database name')
    parser.add_option('-r', '--resultfile', action='store', type='string', dest='resultfile', default='', help='File to save result')

    (options, args) = parser.parse_args()

    fid =  None

    if len(args) != 1:
        parser.error("You must specify file to be parsed")

    if not options.resultfile:
        parser.error("You must specify result")

    try: resultfile = open(options.resultfile, 'w')
    except: parser.error("Error opening resultfile")

    try:
        conn = psycopg2.connect("dbname='%s' user='%s' host='%s' password='%s'"%(options.dbname, options.username, options.hostname, options.password))
        cur = conn.cursor()

        infile = open(args[0], 'r')

        infile.seek(0)

        linecnt = 0
        results = []
        
        for line in infile: 
            result = eval(line)
            if result:
                results.append(linecnt)
            linecnt += 1

    except:
        print "ERROR %s"%(sys.exc_info()[1]);
        traceback.print_exc()


    print "\nCount: %s" % len(results)        

    pickle.dump(results, resultfile)
    resultfile.close()

def locationQuery(timestamp, lat, lon, imei, values):
    global cur, filelength, handled, truelocations, estimatedlocations, dumpfile, dumpcell, resultfile
    
    if len(values) > 1: #skip fingerprints only containing a single serving cell (they make no sense for this algo)
        areas = []
        for entry in values:
            if entry['type'] == 'gsm':
                cur.execute("SELECT cid FROM cells WHERE la =%s AND mcc =%s AND mnc =%s AND cellid =%s;" % (entry['la'], entry['mcc'], entry['mnc'], entry['cellid']))
                cidres =  cur.fetchall()
                if cidres: 
                    cur.execute("SELECT area FROM algotestground.cellareas WHERE cid=%s AND rxlev=%s;" % (cidres[0][0], entry['rxlev']))
            elif entry['type'] == 'neighbour':
                if 'psc' in entry:
                    cur.execute("SELECT area FROM algotestground.neighbourareas3g WHERE psc=%s AND rscp=%s;" % (entry['psc'], entry['rscp']))
                elif 'cellid' in entry:
                    cur.execute("SELECT cid FROM cells WHERE la =%s AND mcc =%s AND mnc =%s AND cellid =%s;" % (entry['la'], entry['mcc'], entry['mnc'], entry['cellid']))
                    cidres =  cur.fetchall()
                    if cidres:
                        cur.execute("SELECT area FROM algotestground.neighbourareas WHERE cid=%s AND rxlev=%s;" % (cidres[0][0], entry['rxlev']))

            result = cur.fetchall()
            if len(result) > 0: 
                newpol = [(float(y[0]), float(y[1])) for y in [x.split(',') for x in result[0][0].split(';')]]
                if len(newpol) > 3: 
                    return True

    return False

if __name__ == "__main__":
    main()

