#!/usr/bin/env python
"""


@author: Brendan Johan Lee
@contact: brendajl@simula.no
@version: 1.0
"""

import psycopg2, sys
from optparse import OptionParser
import traceback
from gloclibs.algorithms import *
import time

def main():
    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options]", description='Create area database')
    parser.add_option('-p', '--password', action='store', type='string', dest='password', default='', help='Set database password')
    parser.add_option('-u', '--username', action='store', type='string', dest='username', default='', help='Set database username')
    parser.add_option('-n', '--hostname', action='store', type='string', dest='hostname', default='localhost', help='Set database hostname')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default='gloc', help='Set database name')

    (options, args) = parser.parse_args()

    try:
        conn = psycopg2.connect("dbname='%s' user='%s' host='%s' password='%s'"%(options.dbname, options.username, options.hostname, options.password))
        cur = conn.cursor()

        t0 = time.time()
        
        cur.execute("SELECT *  FROM algotestground.wlanareas;")
        result =  cur.fetchall()
        for wlanrx in result:
            cur.execute("SELECT b.latitude, b.longitude FROM wlanobservations a,  gps b,  fingerprints c WHERE bssid='%s' AND rxlev=%s AND a.fid = b.fid AND a.fid = c.fid;" % (wlanrx[0], wlanrx[1]))
            points = cur.fetchall()
            cur.execute("UPDATE algotestground.wlanareas SET area ='%s' WHERE bssid='%s' AND rxlev =%s;" % (";".join(["%s,%s" % x for x in hulls(points)]), wlanrx[0], wlanrx[1]))
            conn.commit()

        print "Time 2: ", time.time() - t0
        t0 = time.time()            

    except:
        print "ERROR %s"%(sys.exc_info()[1]);
        traceback.print_exc()

if __name__ == "__main__":
    main()
