#!/usr/bin/env python
"""


@author: Brendan Johan Lee
@contact: brendajl@simula.no
@version: 1.0
"""

import psycopg2, sys
from optparse import OptionParser
import traceback, pickle

def main():
    
    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Create a mapfile from an sql statement')
    parser.add_option('-s', '--statement', action='store', type='string', dest='statement', default='SELECT latitude, longitude FROM gps LIMIT 10;', help='SQL statement to run')
    parser.add_option('-p', '--password', action='store', type='string', dest='password', default='', help='Set database password')
    parser.add_option('-u', '--username', action='store', type='string', dest='username', default='', help='Set database username')
    parser.add_option('-n', '--hostname', action='store', type='string', dest='hostname', default='localhost', help='Set database hostname')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default='gloc', help='Set database name')

    (options, args) = parser.parse_args()

    if len(args) != 1:
        parser.error("You must specify file to create")

    conn = psycopg2.connect("dbname='%s' user='%s' host='%s' password='%s'"%(options.dbname, options.username, options.hostname, options.password))
    cur = conn.cursor()

    cur.execute(options.statement)
    result = cur.fetchall()

    try: dumpfile = open(args[0], 'w')
    except: parser.error("Error opening dumpfile")

    pickle.dump(result, dumpfile)

    print "Created file with %s entries" % len(result)

if __name__ == "__main__":
    main()

    
