""" 
 Dummyfilter for testing. Takes the first fingerprint and returns the strongest observation of it

 @author: Brendan Johan Lee
 @contact: brendajl@simula.no

 @version: 1.0
"""
import gloclibs.server.update.baseupdatefilter as baseupdatefilter

class Filter(baseupdatefilter.BaseUpdateFilter):
    """ 
    Dummyfilter for testing. Takes the first fingerprint and returns the strongest observation of it

    @author: Brendan Johan Lee
    @contact: brendajl@simula.no

    @version: 1.0
    """

    def run(self):
        """ 
        Run this filter

        @author: Brendan Johan Lee
        @contact: brendajl@simula.no

        @version: 1.0

        @return: result of update
        @rtype: list
        """

        result = self.db.getStrongestGSM(self.fingerprints[0]['mcc'],self.fingerprints[0]['mnc'],self.fingerprints[0]['la'],self.fingerprints[0]['cellid'])
        if len(result)<1:
            return {'status':'No data found'}
        return {'status':'Estimated position','latitude':result[0][8],'longitude':result[0][9]}
