#!/usr/bin/env python
"""


@author: Brendan Johan Lee
@contact: brendajl@simula.no
@version: 1.0
"""

import sqlite3
from optparse import OptionParser

class Fingerprint():
    """
    
    
    @author: Brendan Johan Lee
    @contact: brendajl@simula.no
    @version: 1.0
    """
    
    def __init__(self, mcc, mnc, la, cid, rxlev, lat, lon, time):
        """
	
        
        @param mcc: 
        @type mcc: 
        @param mnc: 
        @type mnc: 
        @param la: 
        @type la: 
        @param cid: 
        @type cid: 
        @param rxlev: 
        @type rxlev: 
        @param lat: 
        @type lat: 
        @param lon: 
        @type lon: 
        

        @author: Brendan Johan Lee
        @contact: brendajl@simula.no
        @version: 1.0
        """
        self.mcc = mcc
        self.mnc = mnc
        self.la = la
        self.cid = cid
        self.rxlev = rxlev
        self.lat = lat
        self.lon = lon
        self.time =  time
        self.neighbors = []
        self.wlans = []

    def add_wlan(self, wlan):
        self.wlans.append(wlan)

    def add_neighbor(self, neighbor):
        self.neighbors.append(neighbor)

class Wlan(object):
    """
    
    
    @author: Brendan Johan Lee
    @contact: brendajl@simula.no
    @version: 1.0
    """
    
    def __init__(self, bssid, rxlev):
        """
	
        
        @param bssid: 
        @type bssid: 
        @param rxlev: 
        @type rxlev: 
        

        @author: Brendan Johan Lee
        @contact: brendajl@simula.no
        @version: 1.0
        """
        self.bssid = bssid
        self.rxlev = rxlev
        

        
class Vault(object):
    """
    
    
    @author: Brendan Johan Lee
    @contact: brendajl@simula.no
    @version: 1.0
    """
    
    def __init__(self, dbname):
        """
	
        
        @author: Brendan Johan Lee
        @contact: brendajl@simula.no
        @version: 1.0
        """
        self.fingerprints = []
        self.dbname = dbname

    def add_fingerprint(self, fingerprint):
        for fp in self.fingerprints:
            if fp.time == fingerprint.time:
                return False
        self.fingerprints.append(fingerprint)

        
    def add_wlan_to_fingerprint(self, time, bssid, rxlev):
        for fp in self.fingerprints:
            if fp.time == time:
                fp.add_wlan(Wlan(bssid, rxlev))

    def tosql(self):
        conn =  sqlite3.connect(self.dbname)
        cur = conn.cursor()
        for fp in self.fingerprints:
            if fp.lat == "NaN" or fp.lon == "NaN":
                continue
            cur.execute("INSERT INTO fingerprints (cid, la, lat, lon, mcc, mnc, rxlevel) VALUES(%s, %s, %s, %s, %s, %s, %s);" % (fp.cid, fp.la, fp.lat, fp.lon, fp.mcc, fp.mnc, fp.rxlev))
            conn.commit()
            cur.execute("SELECT last_insert_rowid();")
            result = cur.fetchall()
            for wl in fp.wlans:
                cur.execute("INSERT INTO wlan (rxlevel, bssid, fingerprint) VALUES(%s, '%s', %s);" % (wl.rxlev, wl.bssid, result[0][0]))
                conn.commit()
        
def main():

    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Convert .gsm and .wlan files to sqlite queries')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default=None, help='Set database name')
    
    (options, args) = parser.parse_args()

    if not options.dbname:
        parser.error("You must specify database name")
    
    if len(args) != 1:
        parser.error("You must specify file to be parsed")

    fingerprints = Vault(options.dbname)
        
    gsmfile = open("%s.gsm" % args[0], 'r')
    software = gsmfile.readline().rstrip('\r\n')
    version = gsmfile.readline().rstrip('\r\n')
    desc = gsmfile.readline().rstrip('\r\n')

    for line in gsmfile:
        l = line.split(";")
        fingerprints.add_fingerprint(Fingerprint(l[1], l[2], l[3], l[4], l[5], l[11], l[14], l[0]))
    
    wlanfile = open("%s.wlan" % args[0], 'r')
    software = wlanfile.readline().rstrip('\r\n')
    version = wlanfile.readline().rstrip('\r\n')
    desc = wlanfile.readline().rstrip('\r\n')
    desc2 = wlanfile.readline().rstrip('\r\n')

    time = None
    
    for line in wlanfile:
        l = line.split(";")
        if len(l) > 9:
            time = l[0]
        else:
            fingerprints.add_wlan_to_fingerprint(time, l[4],-int(l[6]))

    fingerprints.tosql()

if __name__ == "__main__":
    main()
