#!/usr/bin/env python
"""


@author: Brendan Johan Lee
@contact: brendajl@simula.no
@version: 1.0
"""

import sqlite3
from optparse import OptionParser
import random

def main():

    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Convert .gsm and .wlan files to sqlite queries')
    parser.add_option('-s', '--start', action='store', type='int', dest='start', default=None, help='Set start id')
    parser.add_option('-e', '--end', action='store', type='int', dest='end', default=None, help='Set end id')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default=None, help='Set database name')
    
    (options, args) = parser.parse_args()

    if not options.dbname:
        parser.error("You must specify database name")

    if not options.start: 
        parser.error("You must specify start id")

    if not options.end:
        parser.error("You must specify end id")
    
    sample = random.sample(xrange(options.start, options.end + 1), (options.end - options.start) / 2)

    conn =  sqlite3.connect(options.dbname)
    cur = conn.cursor()
    
    for fp in xrange(options.start, options.end + 1):
        if fp in sample:
            cur.execute("INSERT INTO base SELECT * FROM fingerprints WHERE id = %s;" % fp)
        else: 
            cur.execute("INSERT INTO test SELECT * FROM fingerprints WHERE id = %s;" % fp)

    conn.commit()
            
    #http://stackoverflow.com/questions/2027488/sqlite-select-into
    #todo: separate dabase stuff to two new tables
    #make indexes
    #make make areas scripts (incl. drop table etc)
    #make new analyze scripts
    #win
        
if __name__ == "__main__":
    main()
