#!/usr/bin/env python
"""


@author: Brendan Johan Lee
@contact: brendajl@simula.no
@version: 1.0
"""
#import fileinput
from optparse import OptionParser
import sys

def main(): 

    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Calculate quartiles')
    parser.add_option('-o', '--printok', action='store_true', dest='printok', default=False, help='Only print ok')

    (options, args) = parser.parse_args()

    #Nlist = range(1, 9) + range(11, 31) + range(32, 53)
    #Nlist = range(2, 5) + range(6, 9) + range(11, 31) + range(32, 50) + range(51, 53)
    #Nlist = range(2, 5) + range(6, 9) + range(11, 31) + range(32, 53)
    #Nlist = range(2, 6) + range(7, 9) + range(11, 25) + range(26, 31) + range(32, 53)
    Nlist = range(1, 30) + range(31, 57)

    #dull =  [float(x) for x in fileinput.input() ]
    dull = [float(x) for x in sys.stdin.readlines()]

    print dull
    
    orgdull = dull[:]
    dull.sort()

    q1 =  ((len(dull) + 2 + ((len(dull) % 2) * 1)) / 4) - 1
    q3 =  (((3 * len(dull)) + 2 - ((len(dull) % 2) * 1)) / 4) - 1

    Q1 =  dull[q1]
    Q3 =  dull[q3]

    if ((len(dull) / 2) % 2) == 0:
        Q1 =  (float(Q1 + dull[q1 + 1])) / 2
        Q3 =  (float(Q3 + dull[q3 + 1])) / 2

    if (len(dull) % 2) == 0:
        M = (float(dull[len(dull) / 2 - 1]) + dull[len(dull) / 2]) / 2
    else:
        M = dull[len(dull) / 2]

    IQR = Q3 - Q1
    statmin = Q1 - (1.5 * IQR)
    statmax = Q3 + (1.5 * IQR)

    outliershigh = []
    outlieridshigh = []
    cnt = 0
    for x in orgdull:
        if x > statmax: 
            outliershigh.append(x)
            outlieridshigh.append(Nlist[cnt])
        cnt += 1

    outlierslow = []
    outlieridslow = []
    cnt = 0
    for x in orgdull:
        if x < statmin: 
            outlierslow.append(x)
            outlieridslow.append(Nlist[cnt])
        cnt += 1

    ok = [x for x in Nlist if x not in outlieridshigh]

    if options.printok:
        print " ".join([str(x) for x in ok])
    else: 
        print "Q1 ", Q1
        print "M ", M
        print "Q3 ", Q3
        print "truemin ", dull[0]
        print "truemax ", dull[-1]
        print "statmin ", statmin
        print "statmax ", statmax
        print "low outliers ", outlierslow
        print "low outlier ids ", outlieridslow
        print "high outliers ", outliershigh
        print "high outlier ids ", outlieridshigh
        print "ok ", ok


if __name__ == "__main__":
    main()
