#!/usr/bin/env python
""" 
 Setsuite used to test the gloc XML-RPC backend. Can be used for
 analyzing tracks, etc.

 @author: Brendan Johan Lee
 @contact: brendajl@simula.no

 @version: 1.0
"""
import xmlrpclib, sys, time, pickle
from optparse import OptionParser

if __name__ == '__main__':
    s = xmlrpclib.Server('http://localhost:7080/')
    
    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options]", description='Test gloc xml-rpc interface.')
    parser.add_option('-i', '--infile', action='store', type='string', dest='infile', default=None, help='Inputfile')
    parser.add_option('-o', '--outfile', action='store', type='string', dest='outfile', default=None, help='Outputfile')
    parser.add_option('-m', '--mapfile', action='store', type='string', dest='mapfile', default=None, help='File for loading in map application')

    (options, args) = parser.parse_args()
    
    if not options.infile:
        print "Please specify infile (use --help for more information)"
        sys.exit(1)
    elif not options.outfile and not options.mapfile:
        print "Please specify outfile or mapfile or both (use --help for more information)"
        sys.exit(1)
    elif options.infile == options.outfile or options.infile == options.mapfile:
        print "Input file and output file cannot be the same file"
        sys.exit(1)

    try: 
        infile = open(options.infile, "r")
    except:
        print "Cannot open input file for reading"
        sys.exit(1)
    
    if options.outfile:
        try:
            outfile = open(options.outfile, "w")
        except:
            print "Cannot open output file for writing"
            sys.exit(1)

    if options.mapfile:
        try:
            mapfile = open(options.mapfile, "w")
        except:
            print "Cannot open map file for writing"
            sys.exit(1)

    t1 = time.time()
    counter = 0

    mapoutput = []

    for line in infile:
        result = eval("s.%s"%line)
        if options.outfile:
            outfile.write("%s\n"%result)
        if options.mapfile:
            mapoutput.append(result)
        counter += 1

    if options.mapfile:
        pickle.dump(mapoutput,mapfile)

    t2 = time.time()
    print 'Ran %s command(s) in %0.3f ms' % (counter, (t2-t1)*1000.0)




#TODO: Make functions for having a difffile alse
