#!/usr/bin/env python

import time, sys
import sqlite3
import sets
from optparse import OptionParser
from gloclibs.algorithms import *

def main():

    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Convert .gsm and .wlan files to sqlite queries')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default=None, help='Set database name')

    (options, args) = parser.parse_args()

    if not options.dbname:
        parser.error("You must specify database name")

    conn =  sqlite3.connect(options.dbname)
    cur = conn.cursor()

    t0 = time.time()

    #WE CHEAT HERE AND IGNORE MCC AND MNC ;)

    cur.execute("DROP TABLE IF EXISTS neighboringareas;")
    cur.execute("CREATE TABLE neighboringareas (la NUMERIC, cid NUMERIC, rxlevel NUMERIC, area TEXT);")
    cur.execute("CREATE INDEX neighboringareas_all ON neighboringareas (la, cid, rxlevel);")
    cur.execute("INSERT INTO neighboringareas (la, cid, rxlevel) SELECT DISTINCT b.la,  b.cid,  b.rxlevel FROM base AS a,  neighbors AS b WHERE b.fingerprint =  a.id AND b.la IS NOT NULL;")
    conn.commit()
    cur.execute("SELECT la, cid, rxlevel FROM neighboringareas;")
    result =  cur.fetchall()

    for cellrx in result:
        cur.execute("SELECT lat, lon FROM base AS a, neighbors AS b WHERE b.fingerprint = a.id AND b.la =%s AND b.cid =%s AND b.rxlevel =%s" %(cellrx[0], cellrx[1], cellrx[2]))
        points = cur.fetchall()
        cur.execute("UPDATE neighboringareas SET area='%s' WHERE la=%s AND cid=%s AND rxlevel=%s;" % (";".join(["%s,%s" % x for x in hulls(points)]),cellrx[0], cellrx[1], cellrx[2]))

    conn.commit()

         

    print "Time 2: ", time.time() - t0
    t0 = time.time()

if __name__ == "__main__":
    main()
