#!/usr/bin/env python

import time, sys
import sqlite3
import sets
from optparse import OptionParser
from gloclibs.algorithms import *

def main():

    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Convert .gsm and .wlan files to sqlite queries')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default=None, help='Set database name')

    (options, args) = parser.parse_args()

    if not options.dbname:
        parser.error("You must specify database name")

    conn =  sqlite3.connect(options.dbname)
    cur = conn.cursor()

    t0 = time.time()

    cur.execute("DROP TABLE IF EXISTS neighboringareas3g;")
    cur.execute("CREATE TABLE neighboringareas3g (psc NUMERIC, rscp NUMERIC, area TEXT);")
    cur.execute("CREATE INDEX neighboringareas3g_all ON neighboringareas3g (psc, rscp);")
    cur.execute("INSERT INTO neighboringareas3g (psc, rscp) SELECT DISTINCT b.psc, b.rscp FROM base AS a, neighbors AS b WHERE b.fingerprint = a.id AND b.psc IS NOT NULL;")
    conn.commit()
    cur.execute("SELECT psc, rscp FROM neighboringareas3g;")
    result =  cur.fetchall()

    for cellrx in result:
        cur.execute("SELECT lat, lon FROM base AS a, neighbors AS b WHERE b.fingerprint = a.id AND b.psc =%s AND b.rscp =%s" %(cellrx[0], cellrx[1]))
        points = cur.fetchall()
        cur.execute("UPDATE neighboringareas3g SET area='%s' WHERE psc=%s AND rscp=%s;" % (";".join(["%s,%s" % x for x in hulls(points)]),cellrx[0], cellrx[1]))

    conn.commit()

         

    print "Time 2: ", time.time() - t0
    t0 = time.time()

if __name__ == "__main__":
    main()
