#!/usr/bin/env python

import time, sys
import sqlite3
import sets
from optparse import OptionParser
from gloclibs.algorithms import *

def main():

    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Convert .gsm and .wlan files to sqlite queries')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default=None, help='Set database name')

    (options, args) = parser.parse_args()

    if not options.dbname:
        parser.error("You must specify database name")

    conn =  sqlite3.connect(options.dbname)
    cur = conn.cursor()

    t0 = time.time()

    cur.execute("DROP TABLE IF EXISTS simpleareas;")
    cur.execute("CREATE TABLE simpleareas (mcc NUMERIC, mnc NUMERIC, la NUMERIC, cid NUMERIC, area TEXT);")
    cur.execute("CREATE INDEX simpleareas_all ON simpleareas (mcc, mnc, la, cid);")
    cur.execute("INSERT INTO simpleareas (mcc, mnc, la, cid) SELECT DISTINCT mcc, mnc, la, cid FROM base;")
    conn.commit()
    cur.execute("SELECT cid, mcc, mnc, la FROM simpleareas;")
    result =  cur.fetchall()

    for cellrx in result:
         cur.execute("SELECT lat, lon FROM base WHERE cid =%s AND mcc=%s AND mnc =%s AND la =%s" % (cellrx[0], cellrx[1], cellrx[2], cellrx[3]))
         points = cur.fetchall()
         cur.execute("UPDATE simpleareas SET area ='%s' WHERE cid =%s AND mcc=%s AND mnc =%s AND la =%s;" % (";".join(["%s,%s" % x for x in hulls(points)]),cellrx[0], cellrx[1], cellrx[2], cellrx[3]))

    conn.commit()

         

    print "Time 2: ", time.time() - t0
    t0 = time.time()

if __name__ == "__main__":
    main()
