#!/usr/bin/env python

import time, sys
import sqlite3
import sets
from optparse import OptionParser
from gloclibs.algorithms import *

def main():

    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options] filename", description='Convert .gsm and .wlan files to sqlite queries')
    parser.add_option('-d', '--dbname', action='store', type='string', dest='dbname', default=None, help='Set database name')

    (options, args) = parser.parse_args()

    if not options.dbname:
        parser.error("You must specify database name")

    conn =  sqlite3.connect(options.dbname)
    cur = conn.cursor()

    t0 = time.time()

    cur.execute("DROP TABLE IF EXISTS wlanareas;")
    cur.execute("CREATE TABLE wlanareas (bssid TEXT, rxlevel NUMERIC, area TEXT);")
    cur.execute("CREATE INDEX wlanareas_all ON wlanareas (bssid, rxlevel);")
    cur.execute("INSERT INTO wlanareas (bssid, rxlevel) SELECT DISTINCT bssid, b.rxlevel FROM base AS a, wlan AS b WHERE b.fingerprint = a.id;")
    conn.commit()
    cur.execute("SELECT bssid, rxlevel FROM wlanareas;")
    result =  cur.fetchall()

    for cellrx in result:
        cur.execute("SELECT lat, lon FROM base AS a, wlan AS b WHERE b.fingerprint = a.id AND b.bssid = '%s' AND b.rxlevel =%s" %(cellrx[0], cellrx[1]))
        points = cur.fetchall()
        cur.execute("UPDATE wlanareas SET area='%s' WHERE rxlevel =%s AND bssid='%s';" % (";".join(["%s,%s" % x for x in hulls(points)]),cellrx[1], cellrx[0]))

    conn.commit()

         

    print "Time 2: ", time.time() - t0
    t0 = time.time()

if __name__ == "__main__":
    main()
