#!/usr/bin/env python
"""


@author: Brendan Johan Lee
@contact: brendajl@simula.no
@version: 1.0
"""

from optparse import OptionParser

def main():
    parser = OptionParser(version='%prog 1.0', usage="usage: %prog [options]", description='remove umts fingerprints from results')
    parser.add_option('-u', '--umtsfile', action='store', type='string', dest='umts', default=None, help='umts fingerprint file')
    parser.add_option('-i', '--inputfile', action='store', type='string', dest='input', default=None, help='input file')
    
    (options, args) = parser.parse_args()

    if not options.umts:
        parser.error("You must specify umtsfile name")

    if not options.input:
        parser.error("You must specify inputfile name")

    f =  open(options.umts, 'r')
    u = [ x.rstrip('\n') for x in f ]

    a = open(options.input, 'r')

    for line in a: 
        data = line.split(" ")
        if data[1] not in u:
            print line.rstrip('\n')

if __name__ == "__main__":
    main()

    
