# Copyright (C) 2009 Brendan Johan Lee

# Todo: autoupdate from server...

import appuifw
import e32
import graphics
import thread
import time
import location
import sysinfo
import positioning,sys
import os.path
import time

try:
    import wlantools
    wlan = True
except:
    wlan = False

class Main:
    
    def __init__(self,wlan=False):
        self.wlan = wlan
        self.platform = 'Symbian'
        self.version = 1.0
        appuifw.app.title = u'GSMBlackBox v %s'%self.version
        appuifw.app.body = self.canvas = appuifw.Canvas(event_callback=None, redraw_callback=self.handle_redraw)
        appuifw.exit_key_handler = self.OnExit
        self.second_menu = [(u'Pause', self.pause)]
        self.third_menu = [(u'Start', self.pause)]
        
        self.loop = 1
        self.running = True
        self.sleep = 5
        self.new_data = True
        self.sats = -1

        self.font = (None,14,None)
        self.color = (255,255,255)
        self.bg = (0,0,60)
        self.headcolor = (255,255,255)
        self.headbg = (255,255,255)
        self.highlightbg = (255,0,0)
        self.highlightcolor = (255,0,0)
        self.MAXSIZE = (800,352) # TODO: We should find this from api
        self.LINEHEIGHT = 20
	self.HEADHEIGHT = 44
	self.TABHEIGHT = 16
	self.TABSPACE = 6
        self.storagedir = 'c:\\Data\\Others\\GSMBlackBox\\'

        self.lastlog = ['','','','','','']
        self.observations = 0
        self.wlan_observations = 0
        self.log = {}
        self.wlan_log = {}
        self.wlan_scan_diff = 0

        """(box,TLENGTH_TIME,numb) = img.measure_text(u'23:59:59', font=headfont)
#(box,numb,numb) = img.measure_text(u'ABCDEFGHIJKLMNOPQRSTUVWXY09,()')
#TABHEIGHT = box[3] - box[1] + 2
(box,numb,numb) = img.measure_text(u'ABCDEFGHIJKLMNOPQRSTUVWXYabcdefghijklmnopqrstuvwxyz09,;!#()', font=myfont)
TABHEIGHT = LINEHEIGHT = box[3] - box[1] + 0
LINEY = -box[1] + 1

# Headline size: frame; total height; y position for text
HDLFRAME = 2
(HDLBOX,numb,numb) = img.measure_text(u'C: 99999 W: G:', font=headfont)
HDLH = HDLBOX[3] - HDLBOX[1] + 2*HDLFRAME
HDLY = -HDLBOX[1] + HDLFRAME
HEADHEIGHT = 2*HDLH + 2*HDLFRAME
del HDLBOX, box, numb"""

        self.deltay = self.LINEHEIGHT

        self.nlock = thread.allocate_lock()
        self.vlock = thread.allocate_lock()
        self.glock = thread.allocate_lock()
        
        self.ris1 = 0
        self.ris2 = ''
        self.indice = 0
        self.img = graphics.Image.new(self.canvas.size)

        

        self.HDLFRAME = 4
        (HDLBOX,numb,numb) = self.img.measure_text(u'C: 99999 W: G:', font=self.font)
        self.HDLH = HDLBOX[3] - HDLBOX[1] + 2*self.HDLFRAME
        self.HDLY = -HDLBOX[1] + self.HDLFRAME
        self.HEADHEIGHT = self.HDLH + self.HDLFRAME
        del HDLBOX, numb

        self.tab = 0
        self.tabs = [u"GSM logging",u"GPS",u"WLAN"]
        self.tab_max = len(self.tabs)
        appuifw.app.set_tabs(self.tabs, self.set_tab_event)
        appuifw.app.activate_tab(self.tab)

        self.gps_setup()
        self.file_setup()
        appuifw.app.menu = [(u'Start', self.start)]
        self.OnLoop()

    def add_wlan(self, bssid):
        self.wlan_observations += 1
        if not self.wlan_log.has_key(bssid):
            self.wlan_log[bssid] = 0
        self.wlan_log[bssid] += 1

    def add(self, mcc,mnc,lac,cid):
        self.observations += 1
        if not self.log.has_key(mcc):
            self.log[mcc] = {}
        if not self.log[mcc].has_key(mnc):
            self.log[mcc][mnc] = {}
        if not self.log[mcc][mnc].has_key(lac):
            self.log[mcc][mnc][lac] = {}
        if not self.log[mcc][mnc][lac].has_key(cid):
            self.log[mcc][mnc][lac][cid] = 0
        self.log[mcc][mnc][lac][cid] += 1

    def get_stats(self):
        cnt_mcc = cnt_mnc = cnt_lac = cnt_bsic = cnt_cid = cnt_arfcn = 0
        for mcc, mnc in self.log.items():
            cnt_mcc += 1
            for mnc, lac in mnc.items():
                cnt_mnc += 1
                for lac, cid in lac.items():
                    cnt_lac += 1
                    for cid in cid.keys():
                        cnt_cid += 1
        return cnt_mcc,cnt_mnc,cnt_lac,cnt_cid

    def set_tab_event(self, event):
        self.tab = event

    def file_setup(self):
        if not os.path.isdir(self.storagedir):
            try:
                os.mkdir(self.storagedir)
            except:
                print "Error creating storage directory"
                sys.exit(1)
        d = time.strftime('%d-%m-%Y')
        self.gsm_filename = os.path.join(self.storagedir,'%s.gsm'%d)
        self.wlan_filename = os.path.join(self.storagedir,'%s.wlan'%d)
        printgsmheader = printwlanheader = True
        if os.path.isfile(self.gsm_filename):
            printgsmheader = False
        if os.path.isfile(self.wlan_filename):
            printwlanheader = False
        if printgsmheader:
            self.gsm_file = open(self.gsm_filename, 'w')
            self.gsm_file.write('GSMBlackBox %s v%s\nSysinfo: os_version=%s, sw_version=%s;%s\n'%(self.platform,self.version,sysinfo.os_version(),sysinfo.sw_version(),sysinfo.imei()))
            self.gsm_file.write('time;mcc;mnc;lac;cid;rxlev;horizontal_dop;used_satellites;vertical_dop;time;satellites;latitude;altitude;vertical_accuracy;longtidue;horizontal_accuracy;speed;heading;heading_accuracy;speed_accuracy\n')
        else:
            self.gsm_file = open(self.gsm_filename, 'a')
        if printwlanheader:
            self.wlan_file = open(self.wlan_filename, 'w')
            self.wlan_file.write('GSMBlackBox %s v%s\nSysinfo: os_version=%s, sw_version=%s;%s\n'%(self.platform,self.version,sysinfo.os_version(),sysinfo.sw_version(),sysinfo.imei()))
            self.wlan_file.write('time;horizontal_dop;used_satellites;vertical_dop;time;satellites;latitude;altitude;vertical_accuracy;longtidue;horizontal_accuracy;speed;heading;heading_accuracy;speed_accuracy\n')
            self.wlan_file.write('BeacionInterval;SecurityMode;SSID;BSSID;ConnectionMode;RxLevel;SupportedRates:Channel\n')
        else:
            self.wlan_file = open(self.wlan_filename, 'a')

    def gps_setup(self):
        self.entries = []
        self.available_modules = []

        for module in positioning.modules():
            if module['available'] == 1:
                self.entries.append(module['name'])
                self.available_modules.append(module)
            
        self.gps = appuifw.popup_menu(self.entries)
        if self.gps is None:
            appuifw.note(u'Cannot continue without GPS','error',1)
            sys.exit(1)

        self.gps_info = positioning.module_info(self.available_modules[self.gps]['id'])

        positioning.select_module(self.available_modules[self.gps]['id'])
        positioning.set_requestors([{'type':'service','format':'application','data':'position'}])

    def reset_draw(self):
        self.imgy = self.HEADHEIGHT

    def pause(self):
        #TODO: Should pause GPS too
        self.running = not self.running
        if self.running:
            appuifw.app.menu = self.second_menu
        else:
            appuifw.app.menu = self.third_menu

    def start(self):
        positioning.position(course=1,satellites=1,callback=self.position_callback, interval=100000,partial=1)
        appuifw.app.menu = self.second_menu

    def position_callback(self,event):
        self.glock.acquire()
        self.position = event
        if self.position['satellites']['satellites'] != self.sats:
            self.sats = self.position['satellites']['satellites']
            self.new_data = True
        self.glock.release()
    
    def logger(self, nada):
        #TODO: Main screen doesn't get updated if gps goes on/off?
        #TODO: Posibility of log without gps
#        while self.loop: 
#            self.nlock.acquire()
        if self.running:
            try:
                if self.position['satellites']['used_satellites']>3:
                    loc = location.gsm_location()
                    self.lastlog[0] = u'%s'%loc[0]
                    self.lastlog[1] = u'%s'%loc[1]
                    self.lastlog[2] = u'%s'%loc[2]
                    self.lastlog[3] = u'%s'%loc[3]
                    self.lastlog[4] = u'%s'%sysinfo.signal_dbm()
                    d = time.strftime('%d-%m-%Y %H:%M:%S')
                    self.gsm_file.write('%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s\n'%
                                            (d,loc[0],loc[1],loc[2],loc[3],sysinfo.signal_dbm(),
                                             self.position['satellites']['horizontal_dop'],
                                             self.position['satellites']['used_satellites'],
                                             self.position['satellites']['vertical_dop'],
                                             self.position['satellites']['time'],
                                             self.position['satellites']['satellites'],
                                             self.position['position']['latitude'],
                                             self.position['position']['altitude'],
                                             self.position['position']['vertical_accuracy'],
                                             self.position['position']['longitude'],
                                             self.position['position']['horizontal_accuracy'],
                                             self.position['course']['speed'],
                                             self.position['course']['heading'],
                                             self.position['course']['heading_accuracy'],
                                             self.position['course']['speed_accuracy']))
                    self.add(loc[0],loc[1],loc[2],loc[3])
                #Todo: turn wlan on and off in menu
                    if self.wlan and self.wlan_scan_diff==0:
                        try:
                            self.wlanscan = wlantools.scan(False)
                            self.wlan_file.write('%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s;%s\n'%
                                                (d,
                                                 self.position['satellites']['horizontal_dop'],
                                                 self.position['satellites']['used_satellites'],
                                                 self.position['satellites']['vertical_dop'],
                                                 self.position['satellites']['time'],
                                                 self.position['satellites']['satellites'],
                                                 self.position['position']['latitude'],
                                                 self.position['position']['altitude'],
                                                 self.position['position']['vertical_accuracy'],
                                                 self.position['position']['longitude'],
                                                 self.position['position']['horizontal_accuracy'],
                                                 self.position['course']['speed'],
                                                 self.position['course']['heading'],
                                                 self.position['course']['heading_accuracy'],
                                                 self.position['course']['speed_accuracy']))
                            for lan in self.wlanscan:
                                self.add_wlan(lan['BSSID'])
                                self.wlan_file.write('%s;%s;%s;%s;%s;%s;%s;%s;%s\n'%
                                                     (lan['Capability'],
                                                      lan['BeaconInterval'],
                                                      lan['SecurityMode'],
                                                      lan['SSID'].replace(";",""),
                                                      lan['BSSID'],
                                                      lan['ConnectionMode'],
                                                      lan['RxLevel'],
                                                      lan['SupportedRates'],
                                                      lan['Channel']))
                        except:
                            self.wlanscan = []
                    self.wlan_scan_diff += 1
                    if self.wlan_scan_diff == 5:
                        self.wlan_scan_diff = 0
                    self.new_data = True
            except:
                pass
#            e32.ao_sleep(self.sleep)
#            self.nlock.release()
        
    def OnExit(self):
        self.loop = 0
        self.gsm_file.close()
        self.wlan_file.close()
    
    def OnLoop(self):
        
        while self.loop:
            e32.ao_sleep(0.1)
            
            self.vlock.acquire()
            self.logger(None)
            if self.running and self.new_data: 
                self.handle_redraw(None)
                self.new_data = False
            self.vlock.release()
            e32.ao_sleep(1) #should be global variable


    def handle_redraw(self,area):
        self.reset_draw()
        self.img.clear(0)
        showgps = False
        #TODO: Headline depending uppon tab
        try:
            if self.position['satellites']['used_satellites']<3:
                self.draw_row([(self.position['satellites']['satellites']*4)+5],['No GPS fix. Paused...'],highlight=True)
            else:
                self.draw_row([(self.position['satellites']['satellites']*4)+5],['GSM logging...'],headline=True)
                showgps = True
            self.sats = self.position['satellites']['satellites']
            self.draw_satellites(self.position['satellites']['used_satellites'],self.position['satellites']['satellites'])
        except:
            self.draw_row([0],['No data from GPS yet...'],highlight=True)
            self.sats = -1
        
        if self.tab == 0:
            (cnt_mcc,cnt_mnc,cnt_lac,cnt_cid) = self.get_stats()
            self.draw_row([0,95,190],['Countries:',cnt_mcc,self.lastlog[0]])
            self.draw_row([0,95,190],['Networks:',cnt_mnc,self.lastlog[1]])
            self.draw_row([0,95,190],['Location Areas:',cnt_lac,self.lastlog[2]])
            self.draw_row([0,95,190],['Cells:',cnt_cid,self.lastlog[3]])
            self.draw_row([0,95,140,190],['Observations:',self.observations,'RXlev:',self.lastlog[4]])
        elif self.tab == 1:
            if showgps:
                self.draw_row([0,75],['Latitude:',self.position['position']['latitude']])
                self.draw_row([0,75],['Longitude:',self.position['position']['longitude']])
                self.draw_row([0,75,140,190],['Satellites:',self.position['satellites']['used_satellites'],'H acc:','%.2f'%self.position['position']['horizontal_accuracy']])
                self.draw_row([0,75,140,190],['Altitude:','%.2f'%self.position['position']['altitude'],'V acc:','%.2f'%self.position['position']['vertical_accuracy']])
                self.draw_row([0,75,140,190],['Speed:','%.2f'%self.position['course']['speed'],'Acc:','%.2f'%self.position['course']['speed_accuracy']])
                self.draw_row([0,75,140,190],['Heading:','%.2f'%self.position['course']['heading'],'Acc:','%.2f'%self.position['course']['heading_accuracy']])            
            else:
                self.draw_row([0],[u'No fix'])
        elif self.tab == 2:
            if not self.wlan:
                self.draw_row([0],[u'To scan WLAN please install wlantools'])
            else:
                self.draw_row([140,180],[u'Nets:',len(self.wlan_log)])
                self.draw_row([140,180],[u'Obs:',self.wlan_observations])
                self.reset_draw()
                self.draw_row([0],[u''])
                if len(self.wlanscan)>0:
                    cnt = 0
                    for lan in self.wlanscan:
                        ssid = lan['SSID']
                        if len(ssid)<1:
                            ssid = '<NO SSID>'
                        self.draw_row([0],[ssid],small=True)
                else:
                    self.draw_row([0],[u'No networks found'])

        self.canvas.blit(self.img)

    def draw_satellites(self, inuse, total):
        col = 0x008000
        for i in range(total):
            if i == inuse:
                col = 0x555555
            self.img.rectangle((1+(i*4), self.imgy-30, 4+(i*4), self.imgy-20), fill=col)

    def draw_row(self, xlist, textlist, space=0, width=320, headline=False, highlight=False, italic=False, small=False):
        tablefont = self.font
        if small:
            tablefont = 'annotation'
	if headline: 
		self.img.rectangle((0,self.imgy-(self.HDLH-2*self.HDLFRAME)-1,width,self.imgy+1),self.headcolor,fill=self.headbg)
        if highlight: 
		self.img.rectangle((0,self.imgy-(self.HDLH-2*self.HDLFRAME)-1,width,self.imgy+1),self.highlightcolor,fill=self.highlightbg)
	if italic:
		tablefont = (self.font[0],self.font[1],self.font[2]|FONT_ITALIC)
	for i in range(len(xlist)):
		x = xlist[i]
		if x < 0:
			x += width
		if highlight or headline:
			self.img.text((x, self.imgy), unicode(textlist[i]), fill=self.bg, font=tablefont)
		else:
			self.img.text((x, self.imgy), unicode(textlist[i]), fill=self.color, font=tablefont)
	self.imgy += self.deltay + space
        if small:
            self.imgy -= 4


        
if __name__ == '__main__':
    main = Main(wlan)
